#pragma once

#include <string>

#include "GL/glew.h"
#include <GLFW/glfw3.h>

extern const int WIDTH;
extern const int HEIGHT;
extern const float ASPECT;

int initGraphics(GLFWwindow** window, const std::string& title);

GLuint compileShaderProgram(const std::string& fragShaderPath);
GLuint compileShader(const std::string& shaderPath, GLenum shaderType);
GLint getShaderUniformLocation(GLuint shaderProgram, const std::string& uniformName);

void updateProjectionMatrix(GLuint shaderProgram);
void updateModelMatrix(GLuint shaderProgram, float time);
void updateViewMatrix(GLuint shaderProgram);
void updateModelViewProjectionMatrix(GLuint shaderProgram, float time);